/*
 * Copyright (c) 2017 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef IDLC_C_GEN_C_HEADER_GEN_BASE_CB_H_
#define IDLC_C_GEN_C_HEADER_GEN_BASE_CB_H_

const char CB_EXPLICIT_LINKAGE_OPEN[] =
R"__c_cb(
#ifdef __cplusplus
extern "C" {
#endif
)__c_cb";

const char CB_EXPLICIT_LINKAGE_CLOSE[] =
R"__c_cb(
#ifdef __cplusplus
}
#endif
)__c_cb";

const char CB_STRUCT_DECL[] =
R"__c_cb(
typedef struct $$_s *rpc_port_$$_h;
)__c_cb";

const char CB_STRUCT_CTOR[] =
R"__c_cb(
int rpc_port_$$_create(rpc_port_$$_h *h);
)__c_cb";

const char CB_STRUCT_DTOR[] =
R"__c_cb(
int rpc_port_$$_destroy(rpc_port_$$_h h);
)__c_cb";

const char CB_STRUCT_SETTER[] =
R"__c_cb(
int rpc_port_$$_$$_$$(rpc_port_$$_h h, $$$$);
)__c_cb";

const char CB_STRUCT_GETTER[] =
R"__c_cb(
int rpc_port_$$_get_$$(rpc_port_$$_h h, $$$$);
)__c_cb";

const char CB_STRUCT_ITERATOR[] =
R"__c_cb(
int rpc_port_$$_foreach_$$(rpc_port_$$_h h,
        bool (*callback)($$$$, void *user_data), void *user_data);
)__c_cb";

const char CB_STRUCT_CLONER[] =
R"__c_cb(
int rpc_port_$$_clone(rpc_port_$$_h h, rpc_port_$$_h *clone);
)__c_cb";

#endif  // IDLC_C_GEN_C_HEADER_GEN_BASE_CB_H_
