/*
 * Copyright (c) 2017 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef IDLC_C_GEN_C_PROXY_HEADER_GEN_CB_H_
#define IDLC_C_GEN_C_PROXY_HEADER_GEN_CB_H_

const char CB_INTERFACE_DECL[] =
R"__c_cb(
typedef struct ##_s *rpc_port_proxy_##_h;

typedef struct {
    void (*connected)(rpc_port_proxy_##_h h, void *user_data);
    void (*disconnected)(rpc_port_proxy_##_h h, void *user_data);
    void (*rejected)(rpc_port_proxy_##_h h, void *user_data);
} rpc_port_proxy_##_callback_s;
)__c_cb";

const char CB_INTERFACE_CTOR[] =
R"__c_cb(
int rpc_port_proxy_##_create(const char *stub_appid,
        rpc_port_proxy_##_callback_s *callback, void *user_data,
        rpc_port_proxy_##_h *h);
)__c_cb";

const char CB_INTERFACE_CONNECT[] =
R"__c_cb(
int rpc_port_proxy_##_connect(rpc_port_proxy_##_h h);
)__c_cb";

const char CB_INTERFACE_DTOR[] =
R"__c_cb(
int rpc_port_proxy_##_destroy(rpc_port_proxy_##_h h);
)__c_cb";

const char CB_INTERFACE_METHODS[] =
R"__c_cb(
$$rpc_port_proxy_##_invoke_$$(rpc_port_proxy_##_h h$$);
)__c_cb";

const char CB_INTERFACE_DELEGATOR[] =
R"__c_cb(
typedef $$(*$$)($$);
)__c_cb";

const char CB_DELEGATE_CTOR[] =
R"__c_cb(
rpc_port_##_h rpc_port_##_create(## callback, bool once, void *user_data);
)__c_cb";

const char CB_DELEGATE_DISPOSER[] =
R"__c_cb(
int rpc_port_proxy_##_dispose(rpc_port_proxy_$$_h proxy, rpc_port_##_h delegate);
)__c_cb";

#endif  // IDLC_C_GEN_C_PROXY_HEADER_GEN_CB_H_
