/*
 * Copyright (c) 2018 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "idlc/cs_gen/cs_lib_gen.h"

namespace {
#include "idlc/cs_gen/cs_cb_rpc_port.h"
#include "idlc/cs_gen/cs_cb_interop.h"
}

namespace tidl {

CsLibGen::CsLibGen(std::shared_ptr<Document> doc)
    : CsGeneratorBase(doc) {}

void CsLibGen::OnInitGen(std::ofstream& stream) {
  GenCopyright(stream);
  stream << "using System;" << NLine(1)
         << "using System.Collections.Generic;" << NLine(1)
         << "using System.Runtime.InteropServices;" << NLine(1)
         << "using Tizen.Applications;" << NLine(1);
  GenInterop(stream);
  GenRpcPort(stream);
}

void CsLibGen::OnFiniGen(std::ofstream& stream) {}

void CsLibGen::GenInterop(std::ofstream& stream) {
  stream << cs_cb_interop;
}

void CsLibGen::GenRpcPort(std::ofstream& stream) {
  stream << cs_cb_rpc_port;
}

}  // namespace tidl
